// Profilab-DLL mit Stringverarbeitung
// (c) WoB , dient als Muster fr Profilab-DLL's mit Stringbergabe
// erstellt mit DEV-CPP 4.9.9.2, keine Funktionsgarantie
#include <windows.h>
#include <string.h>
using namespace std;

#define DLLEXPORT extern"C" __declspec(dllexport)
int WINAPI WinMain ( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR szComdLine, int iCmdShow);

// Typdefinition fr Stringein-/ausgabe nach Beispiel aus Profilab
typedef char *PChar;
typedef PChar StringParam[100]; // String hat laut Profilab max.1000 Zeichen
char OutString1[1000]; // Ausgabestring 1 als globale Variable
char OutString2[1000]; // Ausgabestring 2 als globale Variable
// weitere OutStrings nach Bedarf
// InStrings nicht erforderlich bei Einhaltung der Reihenfolge

// Definition der Eingnge zur besseren Lesbarkeit
unsigned char Anzahl_Eingaenge=2;
const unsigned char InStr=0; // Eingabestring
const unsigned char En=1;    // Digitaleingang

// Definition der Ausgnge zur besseren Lesbarkeit
unsigned char Anzahl_Ausgaenge=2;
const unsigned char OutStr1=0; // Ausgabestring 1
const unsigned char OutStr2=1; // Ausgabestring 2

// Aufruf von PROFILAB, liest Anzahl der Eingnge
DLLEXPORT unsigned char _stdcall NumInputs()
{
  return Anzahl_Eingaenge;
}

// Aufruf von PROFILAB, liest Anzahl der Ausgnge
DLLEXPORT unsigned char _stdcall NumOutputs()
{
  return Anzahl_Ausgaenge;
}

// Aufruf von PROFILAB, liest die Namen der Eingnge
DLLEXPORT void _stdcall GetInputName(unsigned char Nummer, char *Name)
{
  switch(Nummer)
  {
     case InStr: {strcpy(Name,"$In"); break;} // Bezeichnung Eingang 0
     case En:    {strcpy(Name,"En");  break;} // Bezeichnung Eingang 1
     default:;
  }
}

// Aufruf von PROFILAB, liest die Namen der Ausgnge
DLLEXPORT void _stdcall GetOutputName(unsigned char Nummer, char *Name)
{
  switch(Nummer)
  {
     case OutStr1: {strcpy(Name,"$Out1");  break;} // Bezeichnung Ausgang 0
     case OutStr2: {strcpy(Name,"$Out2");  break;} // Bezeichnung Ausgang 1
     default:;
  }
}

// Aufruf von PROFILAB, wird bei Simulationsstart aufgerufen
DLLEXPORT void _stdcall CSimStart(double *PInput, double *POutput, double *PUser)
{
  // keine Funktion in dieser DLL
}

// Aufruf von PROFILAB, wird dauerhaft whrend der Simulation aufgerufen und sollte zeitoptimiert sein
DLLEXPORT void _stdcall CCalculateEx(double *PInput, double *POutput, double *PUser, StringParam PStrings)
{
  // Zuweisung auerhalb einer Bedingung
  strcpy(OutString1,PChar(PStrings[InStr]));

  // Zuweisung innerhalb einer Bedingung
  if (PInput[En]>2.5) strcpy(OutString2,PChar(PStrings[InStr]));
  
  // weitere Verarbeitungsschritte nach Bedarf
  
  // am Ende alle Ausgabestrings bertragen
  strcpy(PChar(PStrings[OutStr1]),OutString1);
  strcpy(PChar(PStrings[OutStr2]),OutString2);
  // danach drfen keine Eingabestrings mehr verarbeitet werden
}
// Aufruf von PROFILAB, wird bei Simulationsstopp aufgerufen
DLLEXPORT void _stdcall CSimStop(double *PInput, double *POutput, double *PUser)
{
  // keine Funktion in dieser DLL
}

// Aufruf von PROFILAB, wird im Konfigurationsmen aufgerufen
DLLEXPORT void _stdcall CConfigure(double *PUser)
{
  MessageBox(NULL,TEXT("keine Funktion"),TEXT("Konfiguration"), MB_OK);
}

// Definition des Einstiegspunktes der DLL
BOOL APIENTRY DllMain (HINSTANCE hInst, DWORD reason, LPVOID reserved)
{
  switch (reason)
  {
     case DLL_PROCESS_ATTACH: break;
     case DLL_PROCESS_DETACH: break;
     case DLL_THREAD_ATTACH:  break;
     case DLL_THREAD_DETACH:  break;
  }
  return TRUE;
}
